/****************************************************************************/
/* wbkernel.h - definice pro komunikaci se serverem WinBase602              */
/* (C) Janus Drozd, 1992, 93, 94, 95, 96, 97, 98, 99, 2000                  */
/* verze: 6.0, 6.1 (32-bit)                                                 */
/****************************************************************************/
#ifndef __WBKERNEL_H__
#define __WBKERNEL_H__

#include "general.h"
#include "cdp.h"

#ifdef __cplusplus
extern "C" {
#endif

  // organizacni funkce:
DllKernel void  WINAPI start_package   (void);
DllKernel void  WINAPI send_package    (void);
DllKernel void  WINAPI concurrent      (BOOL state);
DllKernel BOOL  WINAPI answered        (void);
DllKernel BOOL  WINAPI waiting         (sig32 timeout);

  // Chyby a varovani:
DllKernel int   WINAPI Sz_error        (void);
DllKernel int   WINAPI Sz_warning      (void);

  // Vyhledani objektu:
DllKernel BOOL WINAPI Find2_object(const char * name, const uns8 * appl_id, tcateg category, tobjnum * position);
DllKernel BOOL WINAPI Find_object (const char * name, tcateg category, tobjnum * position);
DllKernel BOOL WINAPI Find_object_by_id(const WBUUID uuid, tcateg category, tobjnum * position);

  // Prace s kurzory:
DllKernel BOOL WINAPI Open_cursor        (tobjnum cursdef, tcursnum * curs);
DllKernel BOOL WINAPI Open_cursor_direct (const char * query, tcursnum * curs);
DllKernel BOOL WINAPI Close_cursor       (tcursnum curs);
DllKernel BOOL WINAPI Open_subcursor     (tcursnum supercurs, const char * subcurdef, tcursnum * subcurs);
DllKernel BOOL WINAPI Add_record(tcursnum curs, trecnum * recs, int numofrecs);
DllKernel BOOL WINAPI Super_recnum(tcursnum subcursor, tcursnum supercursor,
                          trecnum subrecnum, trecnum * superrecnum);
DllKernel BOOL WINAPI Translate(tcursnum curs, trecnum crec, int tbord, trecnum * trec);
DllKernel BOOL WINAPI Query_optimization(const char * query, char * buf, int bufsize);

  // Prace se zaznamy:
DllKernel trecnum WINAPI Append(tcurstab curs);
DllKernel trecnum WINAPI Insert(tcurstab curs);
DllKernel trecnum WINAPI Look_up(tcursnum curs, const char * attrname, void * res);
DllKernel BOOL WINAPI Delete             (tcurstab  curs,  trecnum position);
DllKernel BOOL WINAPI Undelete           (ttablenum table, trecnum position);
DllKernel BOOL WINAPI Delete_all_records (tcursnum curs);
DllKernel BOOL WINAPI Rec_cnt            (tcurstab curs, trecnum * recnum);

  // Cteni a zapis dat:
DllKernel BOOL WINAPI Read         (tcurstab cursnum, trecnum position,
  tattrib attr, const modifrec * access, void * buffer);
DllKernel BOOL WINAPI Write        (tcurstab cursnum, trecnum position,
  tattrib attr, const modifrec * access, const void * buffer, uns16 datasize);
DllKernel BOOL WINAPI Read_ind     (tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, void * data);
DllKernel BOOL WINAPI Write_ind    (tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, void * data, uns16 datasize);
DllKernel BOOL WINAPI Read_ind_cnt (tcurstab cursnum, trecnum position,
  tattrib attr, uns16 * count);
DllKernel BOOL WINAPI Write_ind_cnt(tcurstab cursnum, trecnum position,
  tattrib attr, uns16 count);
DllKernel BOOL WINAPI Read_var     (tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, uns32 start, uns32 size, void * buf, uns32 * psize);
DllKernel BOOL WINAPI Write_var    (tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, uns32 start, uns32 size, const void * buf);
DllKernel BOOL WINAPI Read_len     (tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, uns32 * size);
DllKernel BOOL WINAPI Write_len    (tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, uns32 size);
DllKernel BOOL WINAPI Read_record  (tcurstab cursnum, trecnum position,
  void * buf, uns16 datasize);
DllKernel BOOL WINAPI Write_record (tcurstab cursnum, trecnum position,
  const void * buf, uns16 datasize);

  // prava:
DllKernel BOOL WINAPI GetSet_privils(tobjnum user_group_role,
  tcateg subject_categ, ttablenum table, trecnum recnum, t_oper operation,
  uns8 * privils);

  // transakce:
DllKernel BOOL WINAPI Start_transaction  (void);
DllKernel BOOL WINAPI Commit             (void);
DllKernel BOOL WINAPI Roll_back          (void);
DllKernel BOOL WINAPI Set_transaction_isolation_level(t_isolation level);

  // zamky:
DllKernel BOOL WINAPI Read_lock_record   (tcurstab curs, trecnum position);
DllKernel BOOL WINAPI Read_unlock_record (tcurstab curs, trecnum position);
DllKernel BOOL WINAPI Write_lock_record  (tcurstab curs, trecnum position);
DllKernel BOOL WINAPI Write_unlock_record(tcurstab curs, trecnum position);
DllKernel BOOL WINAPI Read_lock_table    (tcurstab curs);
DllKernel BOOL WINAPI Read_unlock_table  (tcurstab curs);
DllKernel BOOL WINAPI Write_lock_table   (tcurstab curs);
DllKernel BOOL WINAPI Write_unlock_table (tcurstab curs);

  // prace s objekty:
DllKernel BOOL WINAPI Insert_object(const char * name, tcateg category, tobjnum * objnum);
DllKernel BOOL WINAPI Relist_objects(void);
DllKernel BOOL WINAPI GetSet_group_role(tobjnum user_or_group,
  tobjnum group_or_role, tcateg subject2, t_oper operation, uns32 * relation);
DllKernel BOOL WINAPI Create_user(const char * logname,
  const char * name1, const char * name2, const char * name3,
  const char * identif,  const WBUUID homesrv,
  const char * password, tobjnum * objnum);
DllKernel BOOL WINAPI Set_password(const char * reserved, const char * password);
DllKernel BOOL WINAPI Create_link(const char * sourcename,
           const char * sourceappl, tcateg category, const char * linkname);
DllKernel BOOL WINAPI Create2_link(const char * sourcename,
           const uns8 * sourceapplid, tcateg category, const char * linkname);
DllKernel BOOL WINAPI Set_appl_starter(tcateg categ, const char * objname);

  // sledovani stavu
DllKernel sig32  WINAPI Available_memory(BOOL local);
DllKernel sig32  WINAPI Used_memory(BOOL local);
DllKernel int    WINAPI Owned_cursors(void);
DllKernel BOOL   WINAPI Database_integrity(BOOL repair,
           uns32 * lost_blocks, uns32 * lost_dheap,
           uns32 * nonex_blocks, uns32 * cross_link, uns32 * damaged_tabdef);
DllKernel BOOL   WINAPI Get_info(kernel_info * kinf);
DllKernel BOOL   WINAPI GetSet_fil_size  (t_oper operation, uns32 * size);
DllKernel BOOL   WINAPI GetSet_fil_blocks(t_oper operation, uns32 * size);
DllKernel char * WINAPI Who_am_I     (void);
DllKernel BOOL   WINAPI Am_I_db_admin  (void);
DllKernel sig32  WINAPI WinBase602_version(void);
DllKernel void   WINAPI Enable_task_switch(BOOL enable);
DllKernel BOOL   WINAPI Compact_database(int margin);
DllKernel BOOL   WINAPI Log_write(const char * text);
DllKernel BOOL   WINAPI Connection_speed_test(int * requests, int * kbytes);
DllKernel BOOL   WINAPI Appl_inst_count(uns32 * count);
DllKernel BOOL   WINAPI Get_logged_user(int index, char * username, char * applname, int * state);
DllKernel BOOL   WINAPI Get_server_info(int info_type, void * buffer, unsigned buffer_size);

  // obalka aplikace v externim jazyce
DllKernel void  WINAPI cdp_init        (cdp_t cdp);
DllKernel sig32 WINAPI cdp_size        (void);
DllKernel cdp_t WINAPI cdp_alloc       (void);
DllKernel void  WINAPI cdp_free        (cdp_t cdp);
DllKernel int   WINAPI link_kernel     (const char * path, int display);
DllKernel void  WINAPI unlink_kernel   (void);
DllKernel int   WINAPI interf_init     (cdp_t cdp, int user);
DllKernel void  WINAPI interf_close    (void);
DllKernel void  WINAPI core_release    (void);
DllKernel BOOL  WINAPI Login           (const char * username, const char * password);
DllKernel BOOL  WINAPI Logout          (void);
DllKernel BOOL  WINAPI Set_application (const char * applname);

  // jine funkce serveru:
DllKernel BOOL WINAPI SQL_execute(const char * statement, uns32 * results);
DllKernel BOOL WINAPI SQL_prepare(const char * statement, uns32 * handle);
DllKernel BOOL WINAPI SQL_exec_prepared(uns32 handle, uns32 * results, int * count);
DllKernel BOOL WINAPI SQL_drop(uns32 handle);
DllKernel BOOL WINAPI Set_sql_option(uns32 optmask, uns32 optval);
DllKernel BOOL WINAPI Break(void);
DllKernel BOOL WINAPI Message_to_clients(const char * msg);
DllKernel BOOL WINAPI Set_progress_report_modulus(unsigned modulus);

  // manipulace s tabulkou:
DllKernel BOOL WINAPI Enable_index(ttablenum table, int which, BOOL enable);
DllKernel BOOL WINAPI Free_deleted(ttablenum table);
DllKernel BOOL WINAPI Compact_table(ttablenum table);

  // agregacni funkce:
DllKernel BOOL WINAPI C_sum  (tcursnum curs, const char * attrname,
  const char * condition, void * result);
DllKernel BOOL WINAPI C_max  (tcursnum curs, const char * attrname,
  const char * condition, void * result);
DllKernel BOOL WINAPI C_min  (tcursnum curs, const char * attrname,
  const char * condition, void * result);
DllKernel BOOL WINAPI C_count(tcursnum curs, const char * attrname,
  const char * condition, trecnum * result);
DllKernel BOOL WINAPI C_avg  (tcursnum curs, const char * attrname,
  const char * condition, void * result);

  // ODBC:
DllKernel BOOL  WINAPI ODBC_open_cursor      (uns32 connection,  tcursnum * curs,  const char * query);
DllKernel uns32 WINAPI ODBC_find_connection  (const char * dsn_name);
DllKernel uns32 WINAPI ODBC_create_connection(const char * dsn_name);
DllKernel uns32 WINAPI ODBC_direct_connection(const char * conn_string);

  // informace o atributech:
typedef BOOL (WINAPI enum_attr)(char * attrname, uns8 attrtype,
                                     uns8 attrmult, uns16 attrspecif);
DllKernel BOOL WINAPI Enum_attributes(ttablenum table, enum_attr * callback);
DllKernel BOOL WINAPI Attribute_info(ttablenum table, const char * attrname,
       tattrib * attrnum, uns8 * attrtype, uns8 * attrmult, uns16 * attrspecif);

  // podpisy a replikace:
DllKernel BOOL WINAPI Signature(window_id hParent, tcursnum cursor, trecnum recnum, tattrib attr, BOOL create, void * param);
DllKernel BOOL WINAPI Repl_control(int optype, int opparsize, void * opparam);
DllKernel BOOL WINAPI Replicate(const char * ServerName, const char * ApplName, BOOL pull);
DllKernel BOOL WINAPI Reset_replication(void);
DllKernel BOOL WINAPI GetSet_next_user(tcurstab curs,
  trecnum position, tattrib attr, t_oper operation, t_valtype valtype, void * value);

  // e-mail
#define WBL_READRCPT   0x0001
#define WBL_DELAFTER   0x0002
#define WBL_PRILOW     0x0004
#define WBL_PRIHIGH    0x0008
#define WBL_SENSPERS   0x0010
#define WBL_SENSPRIV   0x0020
#define WBL_SENSCONF   0x0040
#define WBL_REMSENDNOW 0x0080
#define WBL_MSGINFILE  0x0100
#define WBL_VIEWED     0x0200
#define WBL_FAX        0x0400
#define WBL_REMOTE     0x0800
#define WBL_DELREQ     0x1000

#define WBMT_602       0x00000001
#define WBMT_MAPI      0x00000002
#define WBMT_SMTPOP3   0x00000004
#define WBMT_602REM    0x00010000
#define WBMT_602SP3    0x00020000
#define WBMT_DIALUP    0x00040000

#define ATML_ID        1
#define ATML_SUBJECT   2
#define ATML_SENDER    3
#define ATML_RECIPIENT 4
#define ATML_CREDATE   5
#define ATML_CRETIME   6
#define ATML_RCVDATE   7
#define ATML_RCVTIME   8
#define ATML_SIZE      9 
#define ATML_FILECNT   10
#define ATML_FLAGS     11
#define ATML_STAT      12
#define ATML_MSGID     13
#define ATML_BODY      14

#define ATMF_ID        1
#define ATMF_NAME      2
#define ATMF_SIZE      3
#define ATMF_DATE      4
#define ATMF_TIME      5

#define MBL_BODY       1
#define MBL_FILES      2

#define MBS_NEW        0
#define MBS_OLD        1
#define MBS_DELETED    2

DllKernel DWORD WINAPI InitWBMail(char *Profile, char *PassWord);
DllKernel DWORD WINAPI InitWBMail602(char *EmiPath, char *UserID, char *PassWord);
DllKernel DWORD WINAPI InitWBMail602x(char *Profile);
DllKernel void  WINAPI CloseWBMail(void);

DllKernel DWORD WINAPI LetterCreate(char *Subj, char *Msg, UINT Flags, DWORD *lpLetter);
DllKernel DWORD WINAPI LetterAddAddr(DWORD Letter, char *Addr, char *Type, BOOL CC);
DllKernel DWORD WINAPI LetterAddFile(DWORD Letter, char *fName);
DllKernel DWORD WINAPI LetterSend(DWORD Letter);
DllKernel DWORD WINAPI TakeMailToRemOffice(void);
DllKernel void  WINAPI LetterCancel(DWORD Letter);

DllKernel DWORD WINAPI MailOpenInBox(LPDWORD lpMailBox);
DllKernel DWORD WINAPI MailBoxLoad(DWORD MailBox, UINT Flags);
DllKernel DWORD WINAPI MailBoxGetMsg(DWORD MailBox, DWORD MsgID);
DllKernel DWORD WINAPI MailBoxGetFilInfo(DWORD MailBox, DWORD MsgID);
DllKernel DWORD WINAPI MailBoxSaveFileAs(DWORD MailBox, DWORD MsgID, DWORD FilIdx, char *FilName, char *DstPath);
DllKernel DWORD WINAPI MailBoxDeleteMsg(DWORD MailBox, DWORD MsgID, BOOL RecToo);
DllExport DWORD WINAPI MailGetInBoxInfo(DWORD MailBox, char *mTblName, ttablenum *mTblNum, char *fTblName, ttablenum *fTblNum);
DllExport void  WINAPI MailCloseInBox(DWORD MailBox);
DllExport DWORD WINAPI MailGetType();
DllExport DWORD WINAPI MailDial(char *PassWord);
DllExport DWORD WINAPI MailHangUp();

  // typove konverze:
DllKernel uns32 WINAPI Make_date  (int day, int month, int year);
DllKernel int   WINAPI Day        (uns32 dt);
DllKernel int   WINAPI Month      (uns32 dt);
DllKernel int   WINAPI Year       (uns32 dt);
DllKernel int   WINAPI Quarter    (uns32 dt);
DllKernel uns32 WINAPI Today      (void);
DllKernel uns32 WINAPI Make_time  (int hour, int minute, int second, int sec1000);
DllKernel int   WINAPI Day_of_week(uns32 dt);
DllKernel int   WINAPI Hours      (uns32 tm);
DllKernel int   WINAPI Minutes    (uns32 tm);
DllKernel int   WINAPI Seconds    (uns32 tm);
DllKernel int   WINAPI Sec1000    (uns32 tm);
DllKernel uns32 WINAPI Now        (void);
DllKernel BOOL  WINAPI Like       (const char * s1, const char * s2);
DllKernel BOOL  WINAPI Pref       (const char * s1, const char * s2);
DllKernel BOOL  WINAPI Substr     (const char * s1, const char * s2);
DllKernel void  WINAPI Upcase     (char * str);
DllKernel double WINAPI money2real(monstr * m);
DllKernel BOOL   WINAPI real2money(double d, monstr * m);
DllKernel uns32 WINAPI timestamp2date    (uns32 dtm);
DllKernel uns32 WINAPI timestamp2time    (uns32 dtm);
DllKernel uns32 WINAPI datetime2timestamp(uns32 dt, uns32 tm);
DllKernel void  WINAPI time2str     (uns32 tm,  char * txt, short param);
DllKernel void  WINAPI date2str     (uns32 dt,  char * txt, short param);
DllKernel void  WINAPI timestamp2str(uns32 dtm, char * txt, short param);
DllKernel BOOL  WINAPI str2time     (char * txt, uns32 * tm);
DllKernel BOOL  WINAPI str2date     (char * txt, uns32 * dt);
DllKernel BOOL  WINAPI str2timestamp(char * txt, uns32 * dtm);

  // zastarale funkce
DllKernel BOOL WINAPI Uninst_table (ttablenum table);
DllKernel BOOL WINAPI Save_table   (ttablenum table, const char * filename);
DllKernel BOOL WINAPI Restore_table(ttablenum table, const char * filename);
DllKernel BOOL WINAPI Define_table (const char * name, const char * description);
DllKernel BOOL WINAPI Get_object_rights(const char * objname, tcateg category,
                          const char * username, tright * rights);
DllKernel BOOL WINAPI Set_object_rights(const char * objname, tcateg category,
                          const char * username, tright rights);
DllKernel BOOL WINAPI Get_data_rights(ttablenum table, const char * username,
                tright * rights, tdright * rd_ri, tdright * wr_ri);
DllKernel BOOL WINAPI Set_data_rights(ttablenum table, const char * username,
                tright rights, tdright rd_ri, tdright wr_ri);
DllKernel BOOL WINAPI Create_group (const char * name);
DllKernel BOOL WINAPI User_to_group(tobjnum user, tobjnum group, BOOL state);
DllKernel BOOL WINAPI User_in_group(tobjnum user, tobjnum group, BOOL * state);

////////////////////////////// varianta cd_ //////////////////////////////////

  // organizacni funkce:
DllKernel void  WINAPI cd_start_package   (cdp_t cdp);
DllKernel void  WINAPI cd_send_package    (cdp_t cdp);
DllKernel void  WINAPI cd_concurrent      (cdp_t cdp, BOOL state);
DllKernel BOOL  WINAPI cd_answered        (cdp_t cdp);
DllKernel BOOL  WINAPI cd_waiting         (cdp_t cdp, sig32 timeout);

  // Chyby a varovani:
DllKernel int   WINAPI cd_Sz_error        (cdp_t cdp);
DllKernel int   WINAPI cd_Sz_warning      (cdp_t cdp);
DllKernel BOOL  WINAPI Get_error_num_text (cdp_t cdp, int err, char * buf, unsigned buflen);

  // Vyhledani objektu:
DllKernel BOOL WINAPI cd_Find2_object(cdp_t cdp, const char * name, const uns8 * appl_id, tcateg category, tobjnum * position);
DllKernel BOOL WINAPI cd_Find_object (cdp_t cdp, const char * name, tcateg category, tobjnum * position);
DllKernel BOOL WINAPI cd_Find_object_by_id(cdp_t cdp, const WBUUID uuid, tcateg category, tobjnum * position);

  // Prace s kurzory:
DllKernel BOOL WINAPI cd_Open_cursor        (cdp_t cdp, tobjnum cursdef, tcursnum * curs);
DllKernel BOOL WINAPI cd_Open_cursor_direct (cdp_t cdp, const char * query, tcursnum * curs);
DllKernel BOOL WINAPI cd_Close_cursor       (cdp_t cdp, tcursnum curs);
DllKernel BOOL WINAPI cd_Open_subcursor     (cdp_t cdp, tcursnum supercurs, const char * subcurdef, tcursnum * subcurs);
DllKernel BOOL WINAPI cd_Add_record(cdp_t cdp, tcursnum curs, trecnum * recs, int numofrecs);
DllKernel BOOL WINAPI cd_Super_recnum(cdp_t cdp, tcursnum subcursor, tcursnum supercursor,
                          trecnum subrecnum, trecnum * superrecnum);
DllKernel BOOL WINAPI cd_Translate(cdp_t cdp, tcursnum curs, trecnum crec, int tbord, trecnum * trec);
DllKernel BOOL WINAPI cd_Query_optimization(cdp_t cdp, const char * query, char * buf, int bufsize);

  // Prace se zaznamy:
DllKernel trecnum WINAPI cd_Append(cdp_t cdp, tcurstab curs);
DllKernel trecnum WINAPI cd_Insert(cdp_t cdp, tcurstab curs);
DllKernel trecnum WINAPI cd_Look_up(cdp_t cdp, tcursnum curs, const char * attrname, void * res);
DllKernel BOOL WINAPI cd_Delete             (cdp_t cdp, tcurstab  curs,  trecnum position);
DllKernel BOOL WINAPI cd_Undelete           (cdp_t cdp, ttablenum table, trecnum position);
DllKernel BOOL WINAPI cd_Delete_all_records (cdp_t cdp, tcursnum curs);
DllKernel BOOL WINAPI cd_Rec_cnt            (cdp_t cdp, tcurstab curs, trecnum * recnum);

  // Cteni a zapis dat:
DllKernel BOOL WINAPI cd_Read         (cdp_t cdp, tcurstab cursnum, trecnum position,
  tattrib attr, const modifrec * access, void * buffer);
DllKernel BOOL WINAPI cd_Write        (cdp_t cdp, tcurstab cursnum, trecnum position,
  tattrib attr, const modifrec * access, const void * buffer, uns16 datasize);
DllKernel BOOL WINAPI cd_Read_ind     (cdp_t cdp, tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, void * data);
DllKernel BOOL WINAPI cd_Write_ind    (cdp_t cdp, tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, void * data, uns16 datasize);
DllKernel BOOL WINAPI cd_Read_ind_cnt (cdp_t cdp, tcurstab cursnum, trecnum position,
  tattrib attr, uns16 * count);
DllKernel BOOL WINAPI cd_Write_ind_cnt(cdp_t cdp, tcurstab cursnum, trecnum position,
  tattrib attr, uns16 count);
DllKernel BOOL WINAPI cd_Read_var     (cdp_t cdp, tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, uns32 start, uns32 size, void * buf, uns32 * psize);
DllKernel BOOL WINAPI cd_Write_var    (cdp_t cdp, tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, uns32 start, uns32 size, const void * buf);
DllKernel BOOL WINAPI cd_Read_len     (cdp_t cdp, tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, uns32 * size);
DllKernel BOOL WINAPI cd_Write_len    (cdp_t cdp, tcurstab cursnum, trecnum position,
  tattrib attr, uns16 index, uns32 size);
DllKernel BOOL WINAPI cd_Read_record  (cdp_t cdp, tcurstab cursnum, trecnum position,
  void * buf, uns16 datasize);
DllKernel BOOL WINAPI cd_Write_record (cdp_t cdp, tcurstab cursnum, trecnum position,
  const void * buf, uns16 datasize);

  // prava:
DllKernel BOOL WINAPI cd_GetSet_privils(cdp_t cdp, tobjnum user_group_role,
  tcateg subject_categ, ttablenum table, trecnum recnum, t_oper operation,
  uns8 * privils);

  // transakce:
DllKernel BOOL WINAPI cd_Start_transaction  (cdp_t cdp);
DllKernel BOOL WINAPI cd_Commit             (cdp_t cdp);
DllKernel BOOL WINAPI cd_Roll_back          (cdp_t cdp);
DllKernel BOOL WINAPI cd_Set_transaction_isolation_level(cdp_t cdp, t_isolation level);

  // zamky:
DllKernel BOOL WINAPI cd_Read_lock_record   (cdp_t cdp, tcurstab curs, trecnum position);
DllKernel BOOL WINAPI cd_Read_unlock_record (cdp_t cdp, tcurstab curs, trecnum position);
DllKernel BOOL WINAPI cd_Write_lock_record  (cdp_t cdp, tcurstab curs, trecnum position);
DllKernel BOOL WINAPI cd_Write_unlock_record(cdp_t cdp, tcurstab curs, trecnum position);
DllKernel BOOL WINAPI cd_Read_lock_table    (cdp_t cdp, tcurstab curs);
DllKernel BOOL WINAPI cd_Read_unlock_table  (cdp_t cdp, tcurstab curs);
DllKernel BOOL WINAPI cd_Write_lock_table   (cdp_t cdp, tcurstab curs);
DllKernel BOOL WINAPI cd_Write_unlock_table (cdp_t cdp, tcurstab curs);

  // prace s objekty:
DllKernel BOOL WINAPI cd_Insert_object(cdp_t cdp, const char * name, tcateg category, tobjnum * objnum);
DllKernel BOOL WINAPI cd_Relist_objects(cdp_t cdp);
DllKernel BOOL WINAPI cd_Relist_objects_ex(cdp_t cdp, BOOL extended);
DllKernel BOOL WINAPI cd_GetSet_group_role(cdp_t cdp, tobjnum user_or_group,
  tobjnum group_or_role, tcateg subject2, t_oper operation, uns32 * relation);
DllKernel BOOL WINAPI cd_Create_user(cdp_t cdp, const char * logname,
  const char * name1, const char * name2, const char * name3,
  const char * identif,  const WBUUID homesrv,
  const char * password, tobjnum * objnum);
DllKernel BOOL WINAPI cd_Set_password(cdp_t cdp, const char * reserved, const char * password);
DllKernel BOOL WINAPI cd_Create_link(cdp_t cdp, const char * sourcename,
           const char * sourceappl, tcateg category, const char * linkname);
DllKernel BOOL WINAPI cd_Create2_link(cdp_t cdp, const char * sourcename,
           const uns8 * sourceapplid, tcateg category, const char * linkname);
DllKernel BOOL WINAPI cd_Set_appl_starter(cdp_t cdp, tcateg categ, const char * objname);

  // sledovani stavu
DllKernel sig32  WINAPI cd_Available_memory(cdp_t cdp, BOOL local);
DllKernel sig32  WINAPI cd_Used_memory(cdp_t cdp, BOOL local);
DllKernel int    WINAPI cd_Owned_cursors(cdp_t cdp);
DllKernel BOOL   WINAPI cd_Database_integrity(cdp_t cdp, BOOL repair,
           uns32 * lost_blocks, uns32 * lost_dheap,
           uns32 * nonex_blocks, uns32 * cross_link, uns32 * damaged_tabdef);
DllKernel BOOL   WINAPI cd_Get_info(cdp_t cdp, kernel_info * kinf);
DllKernel BOOL   WINAPI cd_GetSet_fil_size  (cdp_t cdp, t_oper operation, uns32 * size);
DllKernel BOOL   WINAPI cd_GetSet_fil_blocks(cdp_t cdp, t_oper operation, uns32 * size);
DllKernel char * WINAPI cd_Who_am_I     (cdp_t cdp);
DllKernel BOOL   WINAPI cd_Am_I_db_admin  (cdp_t cdp);
DllKernel sig32  WINAPI cd_WinBase602_version(cdp_t cdp);
DllKernel void   WINAPI cd_Enable_task_switch(cdp_t cdp, BOOL enable);
DllKernel BOOL   WINAPI cd_Compact_database(cdp_t cdp, int margin);
DllKernel BOOL   WINAPI cd_Log_write(cdp_t cdp, const char * text);
DllKernel BOOL   WINAPI cd_Connection_speed_test(cdp_t cdp, int * requests, int * kbytes);
DllKernel BOOL   WINAPI cd_Appl_inst_count(cdp_t cdp, uns32 * count);
DllKernel BOOL   WINAPI cd_Get_logged_user(cdp_t cdp, int index, char * username, char * applname, int * state);
DllKernel BOOL   WINAPI cd_Get_server_info(cdp_t cdp, int info_type, void * buffer, unsigned buffer_size);
DllKernel void   WINAPI cd_Get_appl_info(cdp_t cdp, WBUUID appl_uuid, char * appl_name, char * server_name);

  // obalka aplikace v externim jazyce
DllKernel void  WINAPI cd_interf_close   (cdp_t cdp);
DllKernel int   WINAPI cd_connect        (cdp_t cdp, const char * serv_name, int show_type);
DllKernel void  WINAPI cd_disconnect     (cdp_t cdp);
DllKernel BOOL  WINAPI cd_Login          (cdp_t cdp, const char * username, const char * password);
DllKernel BOOL  WINAPI cd_Logout         (cdp_t cdp);
DllKernel BOOL  WINAPI cd_Set_application(cdp_t cdp, const char * applname);
DllKernel BOOL  WINAPI cd_Set_application_ex(cdp_t cdp, const char * applname, BOOL extended);

  // jine funkce serveru:
DllKernel BOOL WINAPI cd_SQL_execute(cdp_t cdp, const char * statement, uns32 * results);
DllKernel BOOL WINAPI cd_SQL_prepare(cdp_t cdp, const char * statement, uns32 * handle);
DllKernel BOOL WINAPI cd_SQL_exec_prepared(cdp_t cdp, uns32 handle, uns32 * results, int * count);
DllKernel BOOL WINAPI cd_SQL_drop(cdp_t cdp, uns32 handle);
DllKernel BOOL WINAPI cd_Set_sql_option(cdp_t cdp, uns32 optmask, uns32 optval);
DllKernel BOOL WINAPI cd_Break(cdp_t cdp);
DllKernel BOOL WINAPI cd_Message_to_clients(cdp_t cdp, const char * msg);
DllKernel BOOL WINAPI cd_Set_progress_report_modulus(cdp_t cdp, unsigned modulus);

  // manipulace s tabulkou:
DllKernel BOOL WINAPI cd_Enable_index(cdp_t cdp, ttablenum table, int which, BOOL enable);
DllKernel BOOL WINAPI cd_Free_deleted(cdp_t cdp, ttablenum table);
DllKernel BOOL WINAPI cd_Compact_table(cdp_t cdp, ttablenum table);

  // agregacni funkce:
DllKernel BOOL WINAPI cd_C_sum  (cdp_t cdp, tcursnum curs, const char * attrname,
  const char * condition, void * result);
DllKernel BOOL WINAPI cd_C_max  (cdp_t cdp, tcursnum curs, const char * attrname,
  const char * condition, void * result);
DllKernel BOOL WINAPI cd_C_min  (cdp_t cdp, tcursnum curs, const char * attrname,
  const char * condition, void * result);
DllKernel BOOL WINAPI cd_C_count(cdp_t cdp, tcursnum curs, const char * attrname,
  const char * condition, trecnum * result);
DllKernel BOOL WINAPI cd_C_avg  (cdp_t cdp, tcursnum curs, const char * attrname,
  const char * condition, void * result);

  // ODBC:
DllKernel BOOL  WINAPI cd_ODBC_open_cursor      (cdp_t cdp, uns32 connection, tcursnum * curs, const char * query);
DllKernel uns32 WINAPI cd_ODBC_find_connection  (cdp_t cdp, const char * dsn_name);
DllKernel uns32 WINAPI cd_ODBC_create_connection(cdp_t cdp, const char * dsn_name);
DllKernel uns32 WINAPI cd_ODBC_direct_connection(cdp_t cdp, const char * conn_string);

  // informace o atributech:
typedef BOOL (WINAPI enum_attr)(char * attrname, uns8 attrtype,
                                     uns8 attrmult, uns16 attrspecif);
DllKernel BOOL WINAPI cd_Enum_attributes(cdp_t cdp, ttablenum table, enum_attr * callback);
DllKernel BOOL WINAPI cd_Attribute_info(cdp_t cdp, ttablenum table, const char * attrname,
       tattrib * attrnum, uns8 * attrtype, uns8 * attrmult, uns16 * attrspecif);

  // podpisy a replikace:
DllKernel BOOL WINAPI cd_Signature(cdp_t cdp, window_id hParent, tcursnum cursor, trecnum recnum, tattrib attr, BOOL create, void * param);
DllKernel BOOL WINAPI cd_Repl_control(cdp_t cdp, int optype, int opparsize, void * opparam);
DllKernel BOOL WINAPI cd_Replicate(cdp_t cdp, const char * ServerName, const char * ApplName, BOOL pull);
DllKernel BOOL WINAPI cd_Reset_replication(cdp_t cdp);
DllKernel BOOL WINAPI cd_GetSet_next_user(cdp_t cdp, tcurstab curs,
  trecnum position, tattrib attr, t_oper operation, t_valtype valtype, void * value);

#ifdef __cplusplus
 } /* of extern "C" */
#endif

#endif  /* !def __WBKERNEL_H__ */

